
import thread

import Global
import log
from EventDestination import EventDestination
from ConditionEvent import ConditionEvent
from ActionEvent import ActionEvent

from RouterCondition import RouterCondition

class ActionCnd(RouterCondition):
    def __init__(self):
        RouterCondition.__init__(self)

    def evaluate(self, event):

        return event.getResult()



class ActionInstanceManager(EventDestination):


    def __init__(self):
        EventDestination.__init__(self, "ActionInstanceManager")

        thread.start_new_thread( self.getActions, () )
        
        Global.router.subscribe(self, ConditionEvent, 1, ConditionEvent.getResult)
        

    # Thread
    def getActions(self):

        while not Global.shutdown:
            event = self.events.get()
            rule = event.getRule()
            if rule.getActionEnabled():
                thread.start_new_thread( self.executeAction, (rule, ) )


    # Thread
    def executeAction(self, rule):
        action = rule.getAction()
        actions = action.getActionItems()
        for action in actions:
            if rule.getActionEnabled():
                Global.log(Global.log.action, Global.log.DEBUG1,  "Executing action for rule '%s'", rule)
                result = action.execute()
                Global.router.publish(self, ActionEvent(rule, result) )
        rule.disable()
