
from xml import xpath
import Global
from ExecActionItem import ExecActionItem
from EventActionItem import EventActionItem
from ZopeActionItem import ZopeActionItem

class ActionManager:

    def __init__(self, monitorParent, actionRef, argCollector=None):
        self.monitorItem = Global.monitor.createItem(monitorParent, "action_manager")
        self.argCollector = argCollector
        actionName = actionRef.firstChild.nodeValue
        self.enabled = actionRef.getAttribute("enabled")
        self.actionItems = []
        
        items = xpath.Evaluate("config/action-defs/action-def[attribute::name='%s']/action-item" % actionName , Global.root)

        for action in items:
            
            type = action.getAttribute("type")
            if type == "script":
                if action.firstChild:
                    executable = action.firstChild.nodeValue
                else:
                    executable = ""
                    
                a = ExecActionItem(self.monitorItem, executable, argCollector)
                self.actionItems.append(a)


            elif type == "event":
                if action.firstChild:
                    type = action.firstChild.nodeValue
                else:
                    type = ""

                e = EventActionItem(self.monitorItem, type, argCollector)
                self.actionItems.append(e)                
                
            elif type == "zopemethod":
                if action.firstChild:
                    pathToMethod = action.firstChild.nodeValue
                else:
                    pathToMethod = ""
                e = ZopeActionItem(self.monitorItem, pathToMethod, argCollector)
                self.actionItems.append(e)

        #actionItem = Global.monitor.createItem(self.monitorItem, "action_def")
        #actionItem.set("type", actionType)
        #actionItem.set("action_string", actionString)
        
    def reset(self):
        pass
            
    def getActionItems(self):
        return self.actionItems
            
    def execute(self):
        for item in self.actionItems:
            item.execute()


