
import xml.dom.ext
from xml import xpath
import Global
import os
import log
import rcerror

from ParamScript import ParamScript

## Output example:
##
## <?xml version="1.0" encoding="ISO8859-1"?>
## <!DOCTYPE events>
## <events>
##  <event type='c' name='clementin'>
##    <parameters>
##      <parameter name='p1'>5</parameter>
##    </parameters>
##  </event>
##  <event type='a' name='apa'>
##    <parameters>
##      <parameter name='p1'>1</parameter>
##    </parameters>
##  </event>
##  <event type='b' name='banan'>
##    <parameters>
##      <parameter name='p2'>3</parameter>
##      <parameter name='p3'>4</parameter>
##      <parameter name='p1'>2</parameter>
##    </parameters>
##  </event>
## </events>




class ExecActionItem:

    def __init__(self, monitorParent, cmd, argCollector):

        self.monitorItem = Global.monitor.createItem(monitorParent, "action_exec_item")

        self.argCollector = argCollector
        self.cmd = cmd
        
    def execute(self):
        
        f = None
        try:
            f = os.popen( self.cmd, "w" )
            f.write('<?xml version="1.0" encoding="ISO8859-1"?>\n<!DOCTYPE events>\n')
            f.write("<events>\n")

            events = self.argCollector.getEvents()
            for event in events:
                f.write("  <event type='%s' name='%s'>\n" % ( event.getType(), self.argCollector.getName(event) ) )
                f.write("    <parameters>\n")
                for arg in event.getArgs():
                    argString = event.getArg(arg)
                    if argString is None:
                        f.write("      <parameter name='%s'/>\n" % arg )
                    else:
                        f.write("      <parameter name='%s'>%s</parameter>\n" %(arg, argString ) )
                    
                f.write("    </parameters>\n")
                f.write("  </event>\n")

            f.write("</events>\n")

            f.close()
            
        except:
            Global.log(Global.log.action, Global.log.ERROR,  "Error while executing command '%s'", self.cmd)
            Global.log(Global.log.action, Global.log.ERROR, "%s" %rcerror.processException())
            return 0
        #finally:
        #    if f:
        #        f.close()

        return 1

            






