
from ConnectableNode import *
from RuntimeMonitor import *
import Global
import log

class NotNode(ConnectableNode):

    def __init__(self, monitorParent):
        ConnectableNode.__init__(self)

        Global.log(Global.log.ced, Global.log.DEBUG2, "Creating not node")
        
        self.monitorItem = Global.monitor.createItem(monitorParent,"not_node")

    def reset(self):

        Global.log(Global.log.ced, Global.log.DEBUG2, "Not node reset")
        self.monitorItem.set("fire", ConnectableNode.TRUE)
        self.fire(ConnectableNode.TRUE)
        
        ConnectableNode.reset(self)

    def getInitNodes(self):
        c = self.getInConnectors()
        ret = []
        for node in c: 
            ret.append( node.getFromNode() )

        return ret


    def inPort(self, connector, msg):

        Global.log(Global.log.ced, Global.log.DEBUG2, "Not node got message: %s", msg)
        
       
        if msg == ConnectableNode.TRUE:
            self.fire(ConnectableNode.FALSE)

        elif msg == ConnectableNode.FALSE:
            self.fire(ConnectableNode.TRUE)

        elif msg == ConnectableNode.ALWAYS_FALSE:
            self.fire(ConnectableNode.ALWAYS_TRUE)
            
        elif msg == ConnectableNode.ALWAYS_TRUE:
            self.fire(ConnectableNode.ALWAYS_FALSE)


    def fire(self, msg):

        self.monitorItem.set("fire", msg)
        connectors = ConnectableNode.getOutConnectors(self)
        for connector in connectors:
            connector.send(msg)
            


