

import Global
from ConnectableNode import *
from RuntimeMonitor import *
import log

class PickupNode(ConnectableNode):

    def __init__(self, monitorParent, name, type):
        ConnectableNode.__init__(self)

        Global.log(Global.log.node, Global.log.DEBUG1, "Creating Pickup node for '%s'", type)

        self.type = type
        self.name = name
        self.monitorItem = Global.monitor.createItem(monitorParent, "pickup_node")
        self.monitorItem.set("pickup_type", type)
        self.eventsPickedup = 0
        self.monitorItem.set("number_pickuped", self.eventsPickedup)
        self.monitorItem.set("fire", 0)
        
    def reset(self):
        self.monitorItem.set("fire", 0)
        self.monitorItem.set("number_pickuped", 0)
        self.eventsPickedup = 0
        
    def __str__(self):
        return "PickupNode(type='%s')" % self.type

    
    def getInitNodes(self):
        return []

    def getType(self):
        return self.type

    def getName(self):
        return self.name
    

    def send(self, event):
        self.inPort(None, event)
        
    def inPort(self, connector, event):

        Global.log(Global.log.node, Global.log.DEBUG1, "Pickup node got event of type '%s'", event.getType() )
        
        self.eventsPickedup = self.eventsPickedup + 1
        
        self.monitorItem.set("fire", 1)
        self.monitorItem.set("number_pickuped", self.eventsPickedup)

        connectors = self.getOutConnectors()
        for connector in connectors:
            connector.send( ConnectableNode.ALWAYS_TRUE )
            
        return 1


         

        
